package com.huimv.video.dhicc.test.request.Car.Sg;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.huimv.video.dhicc.test.config.OauthConfigBaseInfo;
import com.huimv.video.dhicc.test.constant.Constant;
import com.huimv.video.dhicc.test.request.BaseRequest;
import com.huimv.video.dhicc.test.utils.HttpURLConnectionUtil;
import com.huimv.video.dhicc.test.utils.HttpsURLConnectionUtil;
import com.huimv.video.dhicc.test.utils.UrlUtil;
import lombok.Data;

import java.util.HashMap;
import java.util.Map;

@Data
public class ClientCarListRequestSg extends BaseRequest<Object> {


    private Integer pageNum;

    private Integer pageSize;

//    private String method;
//
//    private Map<String,Object> data;


    public ClientCarListRequestSg() {
    }

    public ClientCarListRequestSg(OauthConfigBaseInfo oauthConfigBaseInfo) {
        super(oauthConfigBaseInfo, Constant.HTTP_GET, oauthConfigBaseInfo.getHttpConfigInfo().getPrefixUrl() + Constant.CAR_LIST, true);
    }

    @Override
    public Object doAction() {
        //重置url信息，替换版本号
        this.setUrl(UrlUtil.dealVersion(this.getUrl()));
        //设置请求参数
        setBody();
        //发送请求
        String res = isEnableHttpTest() ? HttpURLConnectionUtil.doGet(this) : HttpsURLConnectionUtil.doGet(this);
        System.out.println(res);
        //获取响应
//        JSONObject jsonObject = JSONObject.parseObject(res);
//        Object data = jsonObject.get("data");
//        GeneralResponse devicePageResponse = JSON.parseObject(res, GeneralResponse.class);
//        System.out.println(data);
        return res;
    }

    private void setBody() {
        //设置请求参数
        Map<String, Object> map = new HashMap<>();
        map.put("pageNum", this.pageNum);
        map.put("pageSize", this.pageSize);
//        map.put("method", this.method);
//        map.put("data", this.data);
        this.setBody(JSON.toJSONString(map));

    }


    public boolean isEnableHttpTest() {
        return super.getOauthConfigBaseInfo().getHttpConfigInfo().isEnableHttpTest();
    }
}
